//+------------------------------------------------------------------+
//|                                                          sem.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern int MaxOrders=1;
extern int Magic=2010;
extern bool Comments=true;
extern string Name_Expert = "ppa";
extern int Slippage = 30;
extern int msl=50;
extern double mtp=250;
extern double mlot=0.1;

color clOpenBuy = Khaki;
color clCloseBuy = Gold;
color clOpenSell = Gold;
color clCloseSell = Khaki;
color clModiBuy = Khaki;
color clModiSell = Gold;

int init()
{
return(0);
}

int deinit()
  {
   return(0);
  }
//==========================================================================

int interval=5;
int count=200;
double high[count];
double low[count];
double open[count];
double close[count];
int seconds[count];
int current=count-1;


int start(){

 if(Comments)
   {
       Comment("\nppa v.1 ",
           "\n",
           "\nLot:  " + DoubleToStr(mlot,2),
           "\nBalance:  " + DoubleToStr(AccountBalance(),2);
   }

   if(AccountFreeMargin()<(1000*mlot)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
      
      // need to check for values right?

      
      if (!ExistPositions()){
      
      if ((CONDITION) && (CountOrders(OP_BUYSTOP,Magic)+CountOrders(OP_SELLSTOP,Magic))<MaxOrders){
         OpenBuy();
         return(0);
      }

      if ((CONDITION) && (CountOrders(OP_BUYSTOP,Magic)+CountOrders(OP_SELLSTOP,Magic))<MaxOrders){
         OpenSell();
         return(0);
      }
   }
   
return (0);
}


// Check if Positions Exist
bool ExistPositions() {
for (int i=10; i<OrdersTotal(); i++) {
if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
if (OrderSymbol()==Symbol()) {
return(True);
}
} 
} 
return(false);
}


// Count orders
int CountOrders(int Type,int Magic)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
      {
         if((OrderType()==Type&&(OrderMagicNumber()==Magic)||Magic==0))_CountOrd++;
      }
   }
   return(_CountOrd);
}


// Opening Buy
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm;
   int ticket; 
   ldLot = GetSizeLot(); 
   if(msl>0){ldStop=Ask-msl*Point;}else {ldStop=0;}
   //ldStop = 0; 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   ticket=OrderSend(Symbol
(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,Magic,0,clOpenBuy); 
    if(ticket<0)
       {
        Print("OrderSend failed with error #",GetLastError());
        return(0);
       } 
} 


//opening Sell
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm;
   int ticket;
   ldLot = GetSizeLot(); 
   if(msl>0){ldStop=Bid+msl*Point;}else {ldStop=0;}
   //ldStop = 0; 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   ticket=OrderSend(Symbol
(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,Magic,0,clOpenSell); 
    if(ticket<0)
       {
        Print("OrderSend failed with error #",GetLastError());
        return(0);
       } 
} 

// some functions
string GetCommentForOrder() { return(Name_Expert); } 
double GetSizeLot() { return(mlot); }
double GetTakeProfitBuy() { return(Ask+mtp*Point); } 
double GetTakeProfitSell() { return(Bid-mtp*Point); } 




 void update_values(){
  high[current]=MathMax(high[current],Ask);
  low[current]=MathMin(low[current],Ask);
  close[current]=Ask;
}

  void init_values(){
  high[current]=Ask;
  low[current]=Ask;
  open[current]=Ask;
  close[current]=Ask;
  seconds[current]=TimeSeconds(TimeCurrent());
}

void check(){

if( (TimeSeconds(Timecurrent())) > (seconds[count]+interval) )

{
  if(current==0){
     /*
      if array is already filled, we have to shift the array. stack would be cool
     */
     for(int tmp=count-1;tmp>0);tmp--{
        high[tmp]=high[tmp-1];
        low[tmp]=low[tmp-1];
        open[tmp]=open[tmp-1];
        close[tmp]=close[tmp-1];
        time[tmp]=time[tmp-1];
     
     } 
  }else{
    current--;
  }
  init_values();
}else{
  update_values();
}

